
using System;
using System.Collections.Generic;
using System.IO;

class driver {

    public static void Main(string[] args) {
	int dsize = 101;
	if (args.Length > 0) {
		dsize = Convert.ToInt32(args[0]);
	}
	Dictionary<string, int> d = new Dictionary<string,int>(dsize);
	string[] wordlist = {"here", "are", "a", "bunch", "of", "words", "with", "some",
		"words", "are", "repeated", "a", "bunch", "of", "times", "or", "even",
		"a", "bunch", "bunch", "are", "words" };
	//for (int i = 0; i<wordlist.Length; i++) wordAdder(d,wordlist[i]);
	wordAdder2(d);
	foreach (KeyValuePair<string,int> kvp in d) {
		//Console.WriteLine("{0}: {1}", kvp.Key, kvp.Value);
		Console.WriteLine("d[{0}] is {1}", kvp.Key, d[kvp.Key]);
	}
	//d.print();
    }

    public static void wordAdder(Dictionary<string,int> d, string w) {
	if (d.ContainsKey(w)) {
		//int count = d.get(w);
		int count = d[w];
		//d.update(w,count+1);
		d[w] = count+1;
	} else {
		d.Add(w,1);
	}
    }

    public static void wordAdder2(Dictionary<string,int> d) {

	string paragraph = "Another way to do hashing is so-called \"open\" hashing: a data object d is simply put into htable[hash(d)]. If that position is taken, the next position is used. For this to work, we need to be sure that htablesize is quite a bit larger (eg at least double) the number of elements added. Deletions require careful thought. See Bailey 15.4.1.";

	string[] separators = {" ", "\t", ".", ",", ";", ":", "-", "(", ")", "'", "\"", "[", "]", "?", "!"};
	char[] separatorsc = {' ', '\t', '.', ',', ';', ':', '-', '(', ')', '\'', '"', '[', ']', '?', '!'};
	string[] sa = paragraph.Split(separatorsc);	// " \t.,;:-()'\"[]?!");
	for (int i = 0; i<sa.Length; i++) {
		if (sa[i] == "") continue;
		wordAdder(d,sa[i]);
	}
    }
}



class dictionary<K,V> : System.Collections.Generic.IEnumerable<KeyValuePair<K,V>> {

    // from MSDN: IEnumerator<KeyValuePair<TKey, TValue>> IEnumerable<KeyValuePair<TKey, TValue>>.GetEnumerator()

    IEnumerator<KeyValuePair<K,V>> IEnumerable<KeyValuePair<K,V>>.GetEnumerator() {
	return foonumerator();
    }
	

    IEnumerator<KeyValuePair<K,V>> foonumerator() {
	for (int i = 0; i<htablesize; i++) {
	    Cell p = htable[i];
	    while (p != null) {
		yield return new KeyValuePair<K,V>(p.getKey(), p.getVal());
		p = p.next();
	    }
	}
	yield break;
    }

    // problem: we MUST implement the non-Generic GetEnumerator.
    // And the non-generic one apparently cannot simply call the generic one.
    // Not even the Softies can do this; cf the reference Dictionary.cs code
    System.Collections.IEnumerator System.Collections.IEnumerable.GetEnumerator() { 
	return foonumerator(); 
    }

    private int htablesize = 101;
    private Cell[] htable; 

    public dictionary(int size) {
	htablesize = size;
	htable = new Cell[htablesize];
	for (int i=0; i<htablesize; i++) htable[i] = null;
    }

    public bool isKeyMember(K key) {
	int h = hash(key);
	Cell p = htable[h];
	while (p!=null) {
		if (key.Equals(p.getKey())) return true;
		p = p.next();
	}
	return false;
    }

    public void print() {
	for (int i = 0; i<htablesize; i++) {
	    Cell p = htable[i];
	    while (p!= null) {
		Console.WriteLine("({0}, {1})", p.getKey(), p.getVal());
		p = p.next();
	    }
	}
    }

    // finds the Cell that corresponds to K
    private Cell findCell(K key) {
	int h = hash(key);
	Cell p = htable[h];
	while (p!=null) {
		if (key.Equals(p.getKey())) return p;
		p = p.next();
	}
	return null;
    }
	

    private int hash(K key) {
	int h = key.GetHashCode() % htablesize;
	if (h<0) h+= htablesize;	// stupid negative numbers
	return h;
    }

    public class Cell {
	private K key_;
	private V val_;
	private Cell  next_;
	public Cell(K k, V v, Cell n) {key_ = k; val_ = v; next_ = n;}
	public K getKey() {return key_;}
	public V getVal() {return val_;}
	public Cell   next() {return next_;}
        public void setVal(V v) {val_ = v;}
        public void setNext(Cell c)   {next_ = c;}
    }	

    public V get(K key) {
	Cell p = findCell(key);
	if (p==null) return default(V);
	return p.getVal();
    }

    /* 
    public V operator [] (K key) {
	return get(key);
    }
    /* */

    /* an *indexer*: */
    public V this [K key] {
    	get {
	    return get(key);
    	}
    }
    /* */

    public void add(K key, V val) {
	if (isKeyMember(key)) return;
	int h = hash(key);
	htable[h] = new Cell(key, val, htable[h]);
    }

    public void update (K key, V val) {
	Cell p = findCell(key);
	if (p==null) {
		add(key,val);
		return;
	}
	p.setVal(val);
    }
}


