using System;
using System.IO;

/**
 * Simple program to create some linked lists.
 */

class driver {
    public static void Main(string[] args) {

	StrSet sl = new StrSet();
	sl.Add("durian");
	sl.Add("cranberry");
	sl.Add("breadfruit");
	sl.print(); Console.WriteLine("==============");
	sl.Add("cranberry");
	sl.Add("durian");
	sl.Add("guava");
	sl.print();
    }
}

class StrSet {

    private StrList sl;
    public StrSet() {sl = new StrList(100); }
    public bool isMember(string s) {
        for (int i=0; i<sl.size(); i++) {
            if (sl.get(i) == s) return true;
        }
        return false;
    }

    public void Add(string s) {
	if (isMember(s)) return;
	sl.Add(s);
    }

    public void print() {
	sl.print();
    }
}



/**
 * Class StrList represents a list of strings; it is our own version
 * of List<string>. 
 * You create the list entries by using Add(), one at a time.
 * Once you have a list, you can print it. 
 * 
 * You can get the nth value with get(n), or set the nth value with set(n, val).
 * If n is out of range, get(n) returns 0 and set(n, val) does nothing.
 * 
 */



class StrList {
    // instance variables - replace the example below with your own
    private string[] elements;
    private int currsize;

    /**
     * Constructor for objects of class StrList
     */
    public StrList()
    {
        // initialise instance variables
        const int defaultCapacity = 5;
        currsize = 0;
        elements = new string[defaultCapacity];
    }

    /**
     * parameter constructor, allowing you to predefine a capacity.
     */
    public StrList(int capacity) {
        currsize = 0;
        elements = new string[capacity];
    }
       
    /**
     * Add() Adds the value y to the list, at position currsize
     * (that is, at the end of the existing list).
     * The size of the list is incremented.
     * If pos = nums.length, there is no more room, so this version doesn't do anything;
     * THAT PART YOU ARE TO FIX!!
     */
    public void Add(string y) {
        if (currsize == elements.Length) {
            Console.WriteLine("no more room to add " + y);     // should not happen!
            return;
        }
        elements[currsize] = y;
        currsize += 1;      // or currsize++
    }
    
    // get nth value, with range check
    public string get(int n) {
        if (n<0 || n >= currsize) {
            Console.WriteLine("Warning: StrList.get() called with out-of-range n = " + n);
            return null;
        }
        return elements[n];
    }
    
    // set nth value, with range check
    public void set(int n, string val) {
        if (n<0 || n >= currsize) {
            Console.WriteLine("Warning: Strlist.set() called with out-of-range n = " + n);
            return;
        }
        elements[n] = val;
    }
    
    public int size() {
        return currsize;
    }

    
     public void print() {
         int i=0;
         while (i<currsize) {
            Console.WriteLine(i + ":  " + elements[i]);
            i++;    
        }
    }
    
    public override bool Equals(System.Object obj) {
        if (obj == null) return false;

        // If parameter cannot be cast to StrList return false.
        StrList s2 = obj as StrList;
        if (s2 == null) return false;

        // now we check the actual data:
        if (currsize != s2.currsize) return false;
	for (int i=0; i< currsize; i++) {
		//if (!(elements[i].equals(s2.elements[i]))) return false;
		if (!(elements[i]==s2.elements[i])) return false;
	}
	return true;
    }

    public override int GetHashCode() {
	int hc = 0; 
	for (int i = 0; i< currsize; i++) {
		hc = hc ^ elements[i].GetHashCode();
	}
	return hc;
     }
}
