
using System;
using System.IO;

class Factorial {

    public static void Main(string[] args) {
  	int N = 10;
	if (args.Length > 0) {
		N = Convert.ToInt32(args[0]);
		Console.WriteLine("N is {0}", N);
	}
        Console.WriteLine(factorial3(N));
    }

    // classic factorial
    public static long factorial1(int N) {
	if (N==1) return 1;
	return N*factorial1(N-1);
    }

    // factorial returning 1 for all N<=1
    public static long factorial2(int N) {
	if (N<=1) return 1;		// safer ???
	return N*factorial2(N-1);
    }

    // factorial that prints its argument and return value
    public static long factorial3(int N) {
        Console.WriteLine("factorial3 called with N={0}", N);
        long retval;
        if (N==1) retval = 1;
        else {
	    /*A*/ long fact =  factorial3(N-1);
            retval = N * fact;
        }
        Console.WriteLine("factorial3({0}) returns {1}", N, retval);
        return retval;
    }


    // tail-recursive version of factorial
    public static long tr_factorial(int n, long prod) {
        if (n==0) return prod;
        return tr_factorial(n-1, n*prod);
    }

    // caller of tail-recursive version
    public static long factorial4(int n) {
	return tr_factorial(n,1);
    }

}
