//answer-cache version of Fibonacci
using System;
using System.IO;
using System.Diagnostics;

class Fibonacci {

    static int callcount;
    static long [] answercache;

    public static void Main(string[] args) {
  	int N = 10;
	if (args.Length > 0) {
		N = Convert.ToInt32(args[0]);
		Console.WriteLine("N is {0}", N);
	}
	Stopwatch s = new Stopwatch();
	s.Start();
        Console.WriteLine(fibonacci(N));
	s.Stop();
	Console.WriteLine("time: {0} milliseconds", s.ElapsedMilliseconds);
	Console.WriteLine("number of calls: " + Fibonacci.callcount);
    }

    public static long fibonacci(int N) {
	answercache = new long[N+1];
	for (int i = 0; i<N; i++) answercache[i] = 0;
	return rfibonacci(N);
    }

    public static long rfibonacci(int N) {
	if (N<=1) return 1;
 	if (answercache[N] != 0) return answercache[N];
	long res = rfibonacci(N-2) + rfibonacci(N-1);
	answercache[N] = res;
	return res;
    }


}
