
using System;
using System.IO;
using System.Diagnostics;

class Fibonacci {

    static long callcount;

    public static void Main(string[] args) {
  	int N = 10;
	Fibonacci.callcount = 0;
	if (args.Length > 0) {
		N = Convert.ToInt32(args[0]);
		Console.WriteLine("N is {0}", N);
	}
	Stopwatch s = new Stopwatch();
	s.Start();
        Console.WriteLine(fibonacci4(N));
	s.Stop();
	Console.WriteLine("time: {0} milliseconds", s.ElapsedMilliseconds);
	Console.WriteLine("number of calls: " + Fibonacci.callcount);
    }

    public static long fibonacci1(int N) {
	callcount++;
	if (N<=1) return 1;
	return fibonacci1(N-2) + fibonacci1(N-1);
    }

    public class longpair {
	long first, second;
	public longpair(long f, long s) {first = f; second = s;}
	public long getfirst()  {return first;}
	public long getsecond() {return second;}
    }

    public static long fibonacci2(int N) {
	longpair res = fib2(N);
	return res.getfirst();
    }

    public static longpair fib2(int N) {
	if (N==1) return new longpair(1,1);
	longpair res = fib2(N-1);
	return new longpair(res.getfirst()+res.getsecond(), res.getfirst());
    }

    public static long fibonacci3(int N) {
	Console.WriteLine("fibonacci3 called with N={0}", N);
	long retval;
	if (N<=1) retval = 1;
	else retval =  fibonacci3(N-2) + fibonacci3(N-1);
	Console.WriteLine("fibonacci3({0}) returns {1}", N, retval);
	return retval;
    }

    private static long[] answer_cache;

    public static long fibonacci4(int N) {
        answer_cache = new long[N+1];
        return rfibonacci(N);
    }

    private static long rfibonacci(int N) {
	if (N<=1) return 1;
        if (answer_cache[N] != 0) return answer_cache[N];
	long res = rfibonacci(N-2) + rfibonacci(N-1);
	answer_cache[N] = res;
	return res;
    }
        

}
