using System;
using System.IO;



/**
 * Class StrList represents a list of strings; it is our own version
 * of List<string>. 
 * You create the list entries by using Add(), one at a time.
 * Once you have a list, you can print it. 
 * 
 * You can get the nth value with get(n), or set the nth value with set(n, val).
 * If n is out of range, get(n) returns 0 and set(n, val) does nothing.
 * 
 */



class intlist {
    // instance variables - replace the example below with your own
    private int[] elements;
    private int currsize;

    /**
     * Constructor for objects of class StrList
     */
    public intlist()
    {
        // initialise instance variables
        const int defaultCapacity = 5;
        currsize = 0;
        elements = new int[defaultCapacity];
    }

    /**
     * parameter constructor, allowing you to predefine a capacity.
     */
    public intlist(int capacity) {
        currsize = 0;
        elements = new int[capacity];
    }
       
    /**
     * Add() Adds the value y to the list, at position currsize
     * (that is, at the end of the existing list).
     * The size of the list is incremented.
     * If pos = nums.length, there is no more room, so this version doesn't do anything;
     * THAT PART YOU ARE TO FIX!!
     */
    public void Add(int y) {
        if (currsize == elements.Length) {
            Console.WriteLine("no more room to add " + y);     // should not happen!
            return;
        }
        elements[currsize] = y;
        currsize += 1;      // or currsize++
    }
    
    // get nth value, with range check
    public int get(int n) {
        if (n<0 || n >= currsize) {
            Console.WriteLine("Warning: StrList.get() called with out-of-range n = " + n);
            return 0;
        }
        return elements[n];
    }
    
    // set nth value, with range check
    public void set(int n, int val) {
        if (n<0 || n >= currsize) {
            Console.WriteLine("Warning: Strlist.set() called with out-of-range n = " + n);
            return;
        }
        elements[n] = val;
    }
    
    public int size() {
        return currsize;
    }

    
     public void print() {
         int i=0;
         while (i<currsize) {
            Console.WriteLine(i + ":  " + elements[i]);
            i++;    
        }
    }

    public bool isMember(int x) {
	for (int i = 0; i< currsize; i++) {
		if (x == get(i)) return true;
	}
	return false;
    }
    
}
