using System;
using System.IO;

/**
 * Simple program to create some integer trees.
 */

class driver {
    public static void Main(string[] args) {
	inttree tree = new inttree();
	int[] nums0 = {6, 8, 4, 1, 7, 37, 5, 18};
	int[] nums1 = {2, 1, 4, 3, 6, 5, 8, 7, 10, 9, 12, 11, 14, 13, 16, 15, 18, 17, 20, 19};
	int[] nums2 = {4, 7, 9, 2, 3, 8, 1, 6, 10, 5};
	int[] nums3 = {5, 8, 9, 2, 4, 8, 1, 3, 6, 10};
	int[] nums = nums0;
	for (int i = 0; i<nums.Length; i++) tree.insert(nums[i]);
	Console.WriteLine("inorder traversal:");
	tree.intraverse();
	Console.WriteLine("sum is {0}, max is {1}, depth is {2}", tree.sum(), tree.max(), tree.depth());
	Console.WriteLine("preorder traversal:");
	tree.pretraverse();
	Console.WriteLine("postorder traversal:");
	tree.posttraverse();
	Console.WriteLine("is 3 in the tree: {0}", tree.search(3));
	Console.WriteLine("is 37 in the tree: {0}", tree.search(37));
	Console.WriteLine("is 5 in the tree: {0}", tree.search(5));
	Console.WriteLine("is 9 in the tree: {0}", tree.search(9));

    }

}

class inttree {
    public class treenode {
	private int data_;
	private treenode left_, right_;
	public treenode(int d, treenode l, treenode r) {data_ = d; left_ = l; right_ = r;}
	public int data() {return data_;}
	public treenode left()  {return left_;}
	public treenode right() {return right_;}
	public void setdata(int v) {data_ = v;}
	public void setleft (treenode tl) {left_ = tl;}
	public void setright(treenode tr) {right_ = tr;}
    }

    private treenode root_ = null;

    public void intraverse() {intraverse(root_, 0);}

    private void intraverse(treenode p, int depth) {
	if (p==null) return;
	intraverse(p.left(), depth+1);
	for (int i=0;i<depth; i++) Console.Write("   ");
	Console.WriteLine(p.data());
	intraverse(p.right(), depth+1);
    }

    public void pretraverse() {pretraverse(root_);}

    private void pretraverse(treenode p) {
	if (p==null) return;
	Console.WriteLine(p.data());
	pretraverse(p.left());
	pretraverse(p.right());
    }

    public void posttraverse() {posttraverse(root_);}

    private void posttraverse(treenode p) {
	if (p==null) return;
	posttraverse(p.left());
	posttraverse(p.right());
	Console.WriteLine(p.data());
    }
  
    // recursively find sum, etc

    public int sum() {return sum(root_);}

    private static int sum(treenode t) {	
	if (t==null) return 0;
	return sum(t.left()) + t.data() + sum(t.right());
    }

    public int max() {return max(root_);}

    private static int max(treenode t) {	
	if (t==null) return 0;
	return max3(max(t.left()), t.data(), max(t.right()));
    }

    private static int max(int x, int y) {
	if (x>y) return x;
	else return y;
    }

    private static int max3(int x, int y, int z) {
	if (x>=y && x>=z) return x;
	if (y>=z) return y;
	return z;
    }

    public int depth() {return depth(root_);}

    private static int depth(treenode t) {	
	if (t==null) return 0;
	return max(depth(t.left()), depth(t.right())) + 1;
    }

    public void insert(int val) {
	if (root_ == null) {
		root_ = new treenode(val, null, null);
		return;
	}
	rinsert(val, root_);
    }

    // recursive insert: does not get called with t==null
    private void rinsert(int val, treenode t) {
	if (val == t.data() ) return;	// should we do something else?
	if (val < t.data()) {
	    if (t.left() == null) {
		t.setleft(new treenode(val, null, null));
	    } else {
		rinsert(val, t.left());
	    }
	} else { // val > t.data()
	    if (t.right() == null) {
		t.setright(new treenode(val, null, null));
	    } else {
		rinsert(val, t.right());
	    }
	}
    }

    public bool search(int val) {
	if (root_ == null) return false;
	else return rsearch(val, root_);
    }

    private bool rsearch(int val, treenode t) {
        if (t==null) return false;	
	else if (val == t.data()) return true;
	else if (val < t.data()) return rsearch(val, t.left());
	else /* (val > t.data()) */ return rsearch(val, t.right());
    }


}
