/**
 * Class Matrix is implemented by a TList of rows.
 */

using System;
using System.IO;
using System.Collections.Generic;

class Matrix {
    // instance variables - replace the example below with your own
    private List<List<double> > m;
		// list of lists
    private int height, width;

    /**
     * Constructor for objects of class TList
     */
    public Matrix(int h, int w)
    {
        // initialize instance variables
        height = h;
	width = w;
        m = new List<List<double>>(height);
	// we must preallocate all the rows
	for (int i = 0; i<height; i++) {
		List<double> theRow = new List<double>(width);
		//theRow.Fill(0.0);
		for(int j=0; j<width; j++) {
			theRow.Add(0);
		}
		// we must preallocate all the slots (columns) in each row
		m.Add(theRow);
	}
    }
       
    public int getwidth() {return width;}
    public int getheight() {return height;}

    // get nth value, with range check
    public double get(int r, int c) {
        if (r<0 || r >= height) {
            Console.WriteLine("Warning: Matrix.get() called with out-of-range row = " + r);
            return 0.0;	
        }
        if (c<0 || c >= width) {
            Console.WriteLine("Warning: Matrix.get() called with out-of-range column = " + c);
            return 0.0;	
        }
        return m[r][c];
    }
    
    // set nth value, with range check
    public void set(int r, int c, double val) {
        if (r<0 || r >= height) {
            Console.WriteLine("Warning: Matrix.set() called with out-of-range row = " + r);
            return;	
        }
        if (c<0 || c >= width) {
            Console.WriteLine("Warning: Matrix.get() called with out-of-range column = " + c);
            return;	
        }
        m[r][c]=val;
    }

    public void print(int fwidth) {
        for (int r = 0; r<height; r++) {
            for (int c=0; c<width; c++) {
                string s = get(r,c).ToString();
                int spacecount;
		int datawidth=fwidth-1;
                if (s.Length < datawidth) datawidth=s.Length;
                if (s.Length > datawidth) s = s.Substring(0,datawidth);    // clip to field width
                spacecount = fwidth-datawidth;
                for (int i=0;i<spacecount;i++) Console.Write(' ');
                Console.Write(s);
            }
            Console.WriteLine();
        }
    }
    
}


