
using System;
using System.IO;

class Rdemo {
    static void Main(string[] args) {
	Ratio r = new Ratio(4,6);
	Console.WriteLine(r);
	Console.WriteLine("numerator={0}", r.getNumerator());
	Console.WriteLine("denominator={0}", r.getDenominator());
	Ratio r1 = new Ratio(3,5);
	Ratio r2 = new Ratio(2,5);
	Ratio r3 = new Ratio(1,3);
	Ratio r4 = r1.add(r3);
	Console.WriteLine(r1);
	//Console.WriteLine(r2.ToString());	// old-fashioned way
	Console.WriteLine(r3);
	Console.WriteLine(r4);
	Console.WriteLine(r2.add(r1));
	Console.WriteLine(r3.add(new Ratio(1,6)));
	string s = r1.ToString();
    }

    static void WriteString(string s) {
	Console.WriteLine(s);
    }
}

class Ratio {
	private int numerator;
	private int denominator;
	public Ratio(int num, int denom) {
	// pre: denom != 0
		numerator = num;
		denominator = denom;
		reduce();
	}

	public int getNumerator() {
		return numerator;
	}

	public int getDenominator() {
		return denominator;
	}

	public double getValue() {
		return (double)numerator/(double)denominator;
	}

	public Ratio add(Ratio other) {
		int newnum = numerator*other.denominator + denominator*other.numerator;
		int newdenom = denominator*other.denominator;
		return new Ratio(newnum, newdenom);
	}

	private void reduce() {
		int divisor = gcd(numerator, denominator);
		if (denominator < 0) divisor = -divisor;
		numerator = numerator / divisor;
		denominator = denominator / divisor;
	}

	// recursive version
	private static int rgcd(int a, int b) {
		if (a<0) return gcd(-a, b);
		if (a==0) {
		    if (b==0) return 1;
		    return b;
		}
		if (b<a) return rgcd(b,a);
		return rgcd(b%a, a);
	}

	// non-recursive version
	private static int gcd(int a, int b) {
	    while (a>0 && b>0) {
       		if (a>=b) a = a % b;
       		else b = b % a;
    	    }
    	    if (a==0) return b; else return a;
	}

	/* */
	public override String ToString() {
		return "" + '[' + numerator + "/" + denominator + ']';
	}
	/* */
}
	
