
/* THREADED simple talk TCP server */
/* can handle multiple CONCURRENT client connections */
/* newline is to be included at client side */
/* conversion from java to C# */

/* to do:
	getPort
	threads
 */

using System;
using System.IO;
using System.Net;
using System.Net.Sockets;
using System.Threading;

class tstalks {
    public tstalks() {}

    static public int destport = 5431;
    static public int bufsize = 512;
    static public Boolean THREADING = true;

    static  void Main(string[] args) {
	TcpListener ss;
	Socket s;
	try {
	    ss = new TcpListener( IPAddress.Any,  destport);
	    ss.Start();		// don't forget this!
 	} 
	catch (SocketException) {
	    Console.Error.WriteLine("can't create server socket");
	    return;
        }
        Console.Error.WriteLine("server starting on port " + destport);

        while(true) { // accept loop
		s = ss.AcceptSocket();
		Console.Error.WriteLine("New connection from port " + Talker.getPort(s));

		if (THREADING) {
			// three-step process for threads:
			// create the class
			// create a thread, with new ThreadStart referencing the class method chosen
			// Start() the thread
			Talker talk = new Talker(s);		
			Thread talkthr = new Thread(new ThreadStart(talk.line_talker));
			talkthr.Start();
			s=null;
		} else {
			Talker.line_talker(s);
		}

        } // accept loop

    } // end of main

} // end of tstalks class


class Talker {

	private Socket _s;

	public Talker (Socket s) {
		_s = s;
	}

	public void line_talker() { line_talker(_s); }

	public static void line_talker( Socket s) {
		int port = getPort(s);
		Stream istr = new NetworkStream(s);
		StreamReader ir = new StreamReader(istr);

		String buf; // = new byte[bufsize];

		while (true) {	// read a line, print a line
			try {
					buf = ir.ReadLine();
			}
			catch (SocketException) {
				Console.Error.WriteLine("readLine() failed");
				return;
			}

			if (buf == null) {
				//System.err.println("null string!");
				break;
			}

			//buf = buf.concat("\n");

			// byte[] bbuf = buf.getBytes();
			Console.WriteLine("" + port + ": " + buf);	// pick up newline here!
		} //while reading from s

		s.Close();
	} // line_talker

public static int getPort(Socket s) {
	return ((IPEndPoint)s.RemoteEndPoint).Port;
}

/*
class Talker {
	private Socket _s;

	public Talker (Socket s) {
		_s = s;
	}

	public void run() {
		line_talker(_s);
	} // run
}  // class Talker
/* */
}
