/**
 * Class Vector (of reals) is implemented by a List.
 */

using System;
using System.IO;
using System.Collections.Generic;

class Vector {
    // instance variables - replace the example below with your own
    private List<double> m;
    private int length;

    /**
     * Constructor for objects of class TList
     */
    public Vector(int l)
    {
        // initialize instance variables
	length = l;
        m = new List<double>(length);
	// we must preallocate all the rows
	for (int i = 0; i<length; i++) {
		m.Add(0.0);
	}
    }
       
    public int getlength() {return length;}

    // get nth value, with range check
    public double get(int i) {
        if (i<0 || i >= length) {
            Console.WriteLine("Warning: Vector.get() called with out-of-range index = " + i);
            return 0.0;	
        }
        return m[i];
    }
    
    // set nth value, with range check
    public void set(int i, double val) {
        if (i<0 || i >= length) {
            Console.WriteLine("Warning: Vector.set() called with out-of-range index = " + i);
            return;	
        }
        m[i]=val;
    }

    public void print(int fwidth) {
        for (int r = 0; r<length; r++) {
                double val = get(r);
		int leftdigits = ((int) val).ToString().Length;
		int rightdigits = fwidth - leftdigits - 2;
		val = Math.Round(val, rightdigits);
		
		string s = val.ToString();
		int maxlen = leftdigits+rightdigits+1;
		if (s.Length > maxlen) s = s.Substring(0,maxlen);
                int spacecount;
		//int fracdigits = data;
		int datawidth = fwidth -1;
                if (s.Length < datawidth) datawidth=s.Length;
                if (s.Length > datawidth) s = s.Substring(0,datawidth);    // clip to field width
                spacecount = fwidth-datawidth;
                for (int i=0;i<spacecount;i++) Console.Write(' ');
                Console.Write(s);
        }
        Console.WriteLine();
    }

    public static void Main() {

        Vector v = new Vector(8);

        v.set(2,2.71828182845904523536);
        v.set(3,3.14159265358979323844);
        v.set(5,5.85987448204883847380);
        v.set(7,7.07106781186547524400);
        v.print(4);
	v.print(10);
    }
}


